# Pantera Passive Plugin - Check for authetication
#
# FILENAME      : check_for_auth.py
# CODER         : Simon Roses Femerling
# DATE          : 08/25/2006
# LAST UPDATE   : 08/25/2006
# ABSTRACT      : Check for server
#       
# - Roses Labs Innovations (RL+I)
# Roses Labs
# http://www.roseslabs.com
#
# Copyright (c) 2003-2006 Roses Labs.
#
# You may not distribute, transmit, repost this software for commercial 
# purposes without Roses Labs written permission. 
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, publish,
# distribute the Software, and to permit persons to whom the Software 
# is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

'''
@author:       Simon Roses Femerling
@license:      GNU General Public License 2.0 or later
@contact:      pantera.proxy@gmail.com
@organization: OWASP / Roses Labs
'''

from panteraPlugins import PPM
import re

plugin_info =  {'id':"CheckForAuth",
                'name':"Check for Authentication",
                'author':"Simon Roses Femerling",
                'email':"sroses@roseslabs.com",
                'version':"0.1",
                'desc':"Check if page has authentication",
                'tag':"auth"  # defined tags else ignore plugin
                } 

class CheckForAuth(PPM):
    '''
    CheckForAuth class.
    '''
    
    def InitAnalyzer(self):
        '''
        Init function.
        '''
        PPM.__init__(self)
        
    def BeginAnalyzer(self,obj):
        '''
        Begin function.
        '''
        
        # Check if we got a 401 response code
        if obj.serverheader.returncode == '401':
            self.SetLevel('info')
            self.SetResult(1,'auth')
            return
        
        # Check if client header has authorization
        #for h in obj.clientheader.headerValuesDict.keys():
        #    t = h.lower()
        #    if t == 'authorization':
        #        self.SetLevel('info')
        #        self.SetResult(1,'auth')
        #        return
        
# RL+I EOF